import Mathlib.Analysis.Complex.CauchyIntegral
import Mathlib.Analysis.Complex.Basic
import Mathlib.Analysis.Calculus.LineDeriv.Basic
import Mathlib.Analysis.Calculus.ContDiff.Defs
import Mathlib.Analysis.Calculus.FDeriv.Basic
import Mathlib.Analysis.Complex.RealDeriv
import Mathlib.Analysis.Calculus.ContDiff.Basic
import Mathlib.Analysis.Calculus.Deriv.Linear
import Mathlib.Analysis.Complex.Conformal
import Mathlib.Analysis.Calculus.Conformal.NormedSpace
import Mathlib.Analysis.Calculus.FDeriv.Basic
import Mathlib.Analysis.Calculus.FDeriv.RestrictScalars

variable {z : ℂ} {f : ℂ → ℂ} {h : DifferentiableAt ℂ f z}

theorem CauchyRiemann₁ : fderiv ℝ f z Complex.I = Complex.I * fderiv ℝ f z 1 := by
  let A := fderiv ℂ f z
  have t₁ : A (Complex.I • 1) = Complex.I • (A 1) := by
    exact ContinuousLinearMap.map_smul_of_tower A Complex.I 1
  let AR := (ContinuousLinearMap.restrictScalars ℝ (fderiv ℂ f z))
  have t₂ : AR (Complex.I • 1) = Complex.I • (AR 1) := by
    exact t₁
  have t₂a : Complex.I * (AR 1) = Complex.I • (AR 1) := by
    exact rfl
  rw [← t₂a] at t₂
  have t₂b : Complex.I • 1 = Complex.I := by
    simp
  have t₂c : AR Complex.I = Complex.I • (AR 1) := by
    simp at t₂
    exact t₂
  let C : HasFDerivAt f (ContinuousLinearMap.restrictScalars ℝ (fderiv ℂ f z)) z := h.hasFDerivAt.restrictScalars ℝ
  have t₃ : fderiv ℝ f z = ContinuousLinearMap.restrictScalars ℝ (fderiv ℂ f z) := by
    exact DifferentiableAt.fderiv_restrictScalars ℝ h
  rw [t₃]
  exact t₂c
